; *****************************************************************
; *                                                               *
; * Xors3d Engine import file for PureBasic, (c) 2011 XorsTeam    *
; * www:    http://xors3d.com                                     *
; * e-mail: support@xors3d.com                                    *
; *                                                               *
; *****************************************************************

Import "xors3d.lib"
; 3dlines commands
xCreateLine3D.i(fromX.f, fromY.f, fromZ.f, toX.f, toY.f, toZ.f, red.i = 255, green.i = 255, blue.i = 255, alpha.i = 255, useZBuffer.i = #True)
xLine3DOrigin(line3d.i, x.f, y.f, z.f, isGlobal.i = #False)
xLine3DAddNode(line3d.i, x.f, y.f, z.f, isGlobal.i = #False)
xLine3DColor(line3d.i, red.i, green.i, blue.i, alpha.i)
xLine3DUseZBuffer(line3d.i, state.i)
xLine3DOriginX.f(line3d.i, isGlobal.i = #False)
xLine3DOriginY.f(line3d.i, isGlobal.i = #False)
xLine3DOriginZ.f(line3d.i, isGlobal.i = #False)
xLine3DNodesCount.i(line3d.i)
xLine3DNodePosition(line3d.i, index.i, x.f, y.f, z.f, isGlobal.i = #False)
xLine3DNodeX.f(line3d.i, index.i, isGlobal.i = #False)
xLine3DNodeY.f(line3d.i, index.i, isGlobal.i = #False)
xLine3DNodeZ.f(line3d.i, index.i, isGlobal.i = #False)
xLine3DRed.i(line3d.i)
xLine3DGreen.i(line3d.i)
xLine3DBlue.i(line3d.i)
xLine3DAlpha.i(line3d.i)
xGetLine3DUseZBuffer.i(line3d.i)
xDeleteLine3DNode(line3d.i, index.i)
xClearLine3D(line3d.i)

; brushes commands
xLoadBrush.i(path.s, flags.i = 9, xScale.f = 1.0, yScale.f = 1.0)
xCreateBrush.i(red.f = 255.0, green.f = 255.0, blue.f = 255.0)
xFreeBrush(brush.i)
xGetBrushTexture.i(brush.i, index.i = 0)
xBrushColor(brush.i, red.i, green.i, blue.i)
xBrushAlpha(brush.i, alpha.f)
xBrushShininess(brush.i, shininess.f)
xBrushBlend(brush.i, blend.i)
xBrushFX(brush.i, FX.i)
xBrushTexture(brush.i, texture.i, frame.i = 0, index.i = 0)
xGetBrushName_(brush.i) As "_xGetBrushName@4"
xBrushName(brush.i, name.s)
xGetBrushAlpha.f(brush.i)
xGetBrushBlend.i(brush.i)
xGetBrushRed.i(brush.i)
xGetBrushGreen.i(brush.i)
xGetBrushBlue.i(brush.i)
xGetBrushFX.i(brush.i)
xGetBrushShininess.f(brush.i)

; cameras commands
xCameraFogMode(camera.i, mode.i)
xCameraFogColor(camera.i, red.i, green.i, blue.i)
xCameraFogRange(camera.i, nearRange.f, farRange.f)
xCameraClsColor(camera.i, red.i, green.i, blue.i, alpha.i = 255)
xCameraProjMode(camera.i, mode.i)
xCameraClsMode(camera.i, clearColor.i, clearZBuffer.i)
xSphereInFrustum.i(camera.i, x.f, y.f, z.f, radii.f)
xCameraClipPlane(camera.i, index.i, enabled.i, a.f, b.f, c.f, d.f)
xCameraRange(camera.i, nearRange.f, farRange.f)
xCameraViewport(camera.i, x.i, y.i, width.i, height.i)
xCameraCropViewport(camera.i, x.i, y.i, width.i, height.i)
xCreateCamera.i(parent.i = 0)
xCameraProject(camera.i, x.f, y.f, z.f)
xCameraProject2D(camera.i, x.i, y.i, zDistance.f)
xProjectedX.f()
xProjectedY.f()
xProjectedZ.f()
xGetViewMatrix.i(camera.i)
xGetProjectionMatrix.i(camera.i)
xCameraZoom(camera.i, zoom.f)
xGetViewProjMatrix.i(camera.i)

; collisions commands
xCollisions(srcType.i, destType.i, collideMethod.i, response.i)
xClearCollisions()
xResetEntity(entity.i)
xEntityRadius(entity.i, xRadius.f, yRadius.f = 0.0)
xEntityBox(entity.i, x.f, y.f, z.f, width.f, height.f, depth.f)
xEntityType(entity.i, typeID.i, recurse.i = #False)
xEntityCollided.i(entity.i, typeID.i)
xCountCollisions.i(entity.i)
xCollisionX.f(entity.i, index.i)
xCollisionY.f(entity.i, index.i)
xCollisionZ.f(entity.i, index.i)
xCollisionNX.f(entity.i, index.i)
xCollisionNY.f(entity.i, index.i)
xCollisionNZ.f(entity.i, index.i)
xCollisionTime.f(entity.i, index.i)
xCollisionEntity.i(entity.i, index.i)
xCollisionSurface.i(entity.i, index.i)
xCollisionTriangle.i(entity.i, index.i)
xGetEntityType.i(entity.i)

; constants commands
xRenderPostEffect(poly.i)
xCreatePostEffectPoly.i(camera.i, mode.i)
xGetFunctionAddress.i(name.s)

; effects commands
xLoadFXFile.i(path.s)
xFreeEffect(effect.i)
xSetEntityEffect(entity.i, effect.i, index.i = -1)
xSetSurfaceEffect(surface.i, effect.i, index.i = -1)
xSetBonesArrayName(entity.i, arrayName.s, layer.i = -1)
xSurfaceBonesArrayName(surface.i, arrayName.s, layer.i = -1)
xSetEffectInt(entity.i, name.s, value.i, layer.i = -1)
xSurfaceEffectInt(surface.i, name.s, value.i, layer.i = -1)
xSetEffectFloat(entity.i, name.s, value.f, layer.i = -1)
xSurfaceEffectFloat(surface.i, name.s, value.f, layer.i = -1)
xSetEffectBool(entity.i, name.s, value.i, layer.i = -1)
xSurfaceEffectBool(surface.i, name.s, value.i, layer.i = -1)
xSetEffectVector(entity.i, name.s, x.f, y.f, z.f, w.f = 0.0, layer.i = -1)
xSurfaceEffectVector(surface.i, name.s, x.f, y.f, z.f, w.f = 0.0, layer.i = -1)
xSetEffectVectorArray(entity.i, name.s, value.i, count.i, layer.i = -1)
xSurfaceEffectVectorArray(surface.i, name.s, value.i, count.i, layer.i = -1)
xSurfaceEffectMatrixArray(surface.i, name.s, value.i, count.i, layer.i = -1)
xSurfaceEffectFloatArray(surface.i, name.s, value.i, count.i, layer.i = -1)
xSurfaceEffectIntArray(surface.i, name.s, value.i, count.i, layer.i = -1)
xSetEffectMatrixArray(entity.i, name.s, value.i, count.i, layer.i = -1)
xSetEffectFloatArray(entity.i, name.s, value.i, count.i, layer.i = -1)
xSetEffectIntArray(entity.i, name.s, value.i, count.i, layer.i = -1)
xCreateBufferVectors.i(count.i)
xBufferVectorsSetElement(buffer.i, number.i, x.f, y.f, z.f, w.f)
xCreateBufferMatrix.i(count.i)
xBufferMatrixSetElement(buffer.i, number.i, matrix.i)
xBufferMatrixGetElement.i(buffer.i, number.i)
xCreateBufferFloats.i(count.i)
xBufferFloatsSetElement(buffer.i, number.i, value.f)
xBufferFloatsGetElement.f(buffer.i, number.i)
xBufferDelete(buffer.i)
xSetEffectMatrixWithElements(entity.i, name.s, m11.f, m12.f, m13.f, m14.f, m21.f, m22.f, m23.f, m24.f, m31.f, m32.f, m33.f, m34.f, m41.f, m42.f, m43.f, m44.f, layer.i = -1)
xSetEffectMatrix(entity.i, name.s, matrix.i, layer.i = -1)
xSurfaceEffectMatrix(surface.i, name.s, matrix.i, layer.i = -1)
xSurfaceEffectMatrixWithElements(surface.i, name.s, m11.f, m12.f, m13.f, m14.f, m21.f, m22.f, m23.f, m24.f, m31.f, m32.f, m33.f, m34.f, m41.f, m42.f, m43.f, m44.f, layer.i = -1)
xSetEffectEntityTexture(entity.i, name.s, index.i = 0, layer.i = -1)
xSetEffectTexture(entity.i, name.s, texture.i, frame.i = 0, layer.i = -1, isRecursive.i = 1)
xSurfaceEffectTexture(surface.i, name.s, texture.i, frame.i = 0, layer.i = -1)
xSurfaceEffectMatrixSemantic(surface.i, name.s, value.i, layer.i = -1)
xSetEffectMatrixSemantic(entity.i, name.s, value.i, layer.i = -1)
xDeleteSurfaceConstant(surface.i, name.s, layer.i = -1)
xDeleteEffectConstant(entity.i, name.s, layer.i = -1)
xClearSurfaceConstants(surface.i, layer.i = -1)
xClearEffectConstants(entity.i, layer.i = -1)
xSetEffectTechnique(entity.i, name.s, layer.i = -1)
xSurfaceTechnique(surface.i, name.s, layer.i = -1)
xValidateEffectTechnique.i(effect.i, name.s)
xSetEntityShaderLayer(entity.i, layer.i)
xGetEntityShaderLayer.i(entity.i)
xSetSurfaceShaderLayer(surface.i, layer.i)
xGetSurfaceShaderLayer.i(surface.i)
xSetFXInt(effect.i, name.s, value.i)
xSetFXFloat(effect.i, name.s, value.f)
xSetFXBool(effect.i, name.s, value.i)
xSetFXVector(effect.i, name.s, x.f, y.f, z.f, w.f = 0.0)
xSetFXVectorArray(effect.i, name.s, value.i, count.i)
xSetFXMatrixArray(effect.i, name.s, value.i, count.i)
xSetFXFloatArray(effect.i, name.s, value.i, count.i)
xSetFXIntArray(effect.i, name.s, value.i, count.i)
xSetFXEntityMatrix(effect.i, name.s, matrix.i)
xSetFXTexture(effect.i, name.s, texture.i, frame.i = 0)
xSetFXMatrixSemantic(effect.i, name.s, value.i)
xDeleteFXConstant(effect.i, name.s)
xClearFXConstants(effect.i)
xSetFXTechnique(effect.i, name.s)

; emitters commands
xCreateEmitter.i(psystem.i, parent.i = 0)
xEmitterEnable(emitter.i, state.i)
xEmitterEnabled.i(emitter.i)
xEmitterGetPSystem.i(emitter.i)
xEmitterAddParticle.i(emitter.i)
xEmitterFreeParticle(emitter.i, particle.i)
xEmitterValidateParticle.i(emitter.i, particle.i)
xEmitterCountParticles.i(emitter.i)
xEmitterGetParticle.i(emitter.i, index.i)
xEmitterAlive.i(emitter.i)

; entity_animation commands
xExtractAnimSeq.i(entity.i, firstFrame.i, lastFrame.i, sequence.i = 0)
xLoadAnimSeq.i(entity.i, path.s)
xSetAnimSpeed(entity.i, speed.f, rootBone.s = "")
xAnimSpeed.f(entity.i, rootBone.s = "")
xAnimating.i(entity.i, rootBone.s = "")
xAnimTime.f(entity.i, rootBone.s = "")
xAnimate(entity.i, mode.i = 1, speed.f = 1.0, sequence.i = 0, translate.f = 0.0, rootBone.s = "")
xAnimSeq.i(entity.i, rootBone.s = "")
xAnimLength.f(entity.i, rootBone.s = "")
xSetAnimTime(entity.i, time.f, sequence.i, rootBone.s = "")
xSetAnimFrame(entity.i, frame.f, sequence.i, rootBone.s = "")

; entity_control commands
xEntityAutoFade(entity.i, nearRange.f, farRange.f)
xEntityOrder(entity.i, order.i)
xFreeEntity(entity.i)
xCopyEntity.i(entity.i, parent.i = 0, cloneBuffers.i = 0)
xPaintEntity(entity.i, brush.i)
xEntityShininess(entity.i, shininess.f)
xEntityPickMode(entity.i, mode.i, obscurer.i = #True, recursive.i = #True)
xEntityTexture(entity.i, texture.i, frame.i = 0, index.i = 0, isRecursive.i = 1)
xEntityFX(entity.i, fx.i)
xGetParent.i(entity.i)
xSetFrustumSphere(entity.i, x.f, y.f, z.f, radii.f)
xCalculateFrustumVolume(entity.i)
xEntityParent(entity.i, parent.i = 0, isGlobal.i = #True)
xShowEntity(entity.i)
xHideEntity(entity.i)
xNameEntity(entity.i, name.s)
xSetEntityQuaternion(entity.i, quaternion.i)
xSetEntityMatrix(entity.i, matrix.i)
xEntityAlpha(entity.i, alpha.f)
xEntityColor(entity.i, red.i, green.i, blue.i)
xEntitySpecularColor(entity.i, red.i, green.i, blue.i)
xEntityAmbientColor(entity.i, red.i, green.i, blue.i)
xEntityEmissiveColor(entity.i, red.i, green.i, blue.i)
xEntityBlend(entity.i, mode.i)
xEntityAlphaRef(entity.i, value.i)
xEntityAlphaFunc(entity.i, value.i)
xCreateInstance.i(entity.i, parent.i = 0)
xFreezeInstances(entity.i, enable.i = #True)
xInstancingAvaliable.i()
xGetEntityWorld.i(entity.i)
xSetEntityWorld(entity.i, world.i)

; entity_movement commands
xScaleEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xPositionEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xMoveEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xTranslateEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xRotateEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xTurnEntity(entity.i, x.f, y.f, z.f, isGlobal.i = #False)
xPointEntity(entity1.i, entity2.i, roll.f = 0.0)
xAlignToVector(entity.i, x.f, y.f, z.f, axis.i, factor.f = 1.0)

; entity_state commands
xEntityDistance.f(entity1.i, entity2.i)
xGetMatElement.f(entity.i, row.i, col.i)
xEntityClass_(entity.i) As "_xEntityClass@4"
xGetEntityBrush.i(entity.i)
xEntityX.f(entity.i, isGlobal.i = #False)
xEntityY.f(entity.i, isGlobal.i = #False)
xEntityZ.f(entity.i, isGlobal.i = #False)
xEntityVisible.i(entity.i, destination.i)
xEntityScaleX.f(entity.i)
xEntityScaleY.f(entity.i)
xEntityScaleZ.f(entity.i)
xEntityRoll.f(entity.i, isGlobal.i = #False)
xEntityYaw.f(entity.i, isGlobal.i = #False)
xEntityPitch.f(entity.i, isGlobal.i = #False)
xEntityName_(entity.i) As "_xEntityName@4"
xCountChildren.i(entity.i)
xGetChild.i(entity.i, index.i)
xEntityInView.i(entity.i, camera.i)
xFindChild.i(entity.i, name.s)
xGetEntityMatrix.i(entity.i)
xGetEntityAlpha.f(entity.i)
xGetAlphaRef.i(entity.i)
xGetAlphaFunc.i(entity.i)
xEntityRed.i(entity.i)
xEntityGreen.i(entity.i)
xEntityBlue.i(entity.i)
xGetEntityShininess.f(entity.i)
xGetEntityBlend.i(entity.i)
xGetEntityFX.i(entity.i)
xEntityHidden.i(entity.i)
xEntitiesBBIntersect.i(entity1.i, entity2.i)

; filesystems commands
xMountPackFile.i(path.s, mountpoint.s = "", password.s = "")
xUnmountPackFile(packfile.i)
xOpenFile.i(path.s)
xReadFile.i(path.s)
xWriteFile.i(path.s)
xCloseFile(file.i)
xFilePos.i(file.i)
xSeekFile(file.i, offset.i)
xFileType.i(path.s)
xFileSize.i(path.s)
xFileCreationTime.i(path.s)
xFileCreationTimeStr_(path.s) As "_xFileCreationTimeStr@4"
xFileModificationTime.i(path.s)
xFileModificationTimeStr_(path.s) As "_xFileModificationTimeStr@4"
xReadDir.i(path.s)
xCloseDir(handle.i)
xNextFile_(handle.i) As "_xNextFile@4"
xCurrentDir_() As "_xCurrentDir@0"
xChangeDir(path.s)
xCreateDir.i(path.s)
xDeleteDir.i(path.s)
xCopyFile.i(pathSrc.s, pathDest.s)
xDeleteFile.i(path.s)
xEof.i(file.i)
xReadByte.i(file.i)
xReadShort.i(file.i)
xReadInt.i(file.i)
xReadFloat.f(file.i)
xReadString_(file.i) As "_xReadString@4"
xReadLine_(file.i, ls_flag.i) As "_xReadLine@8"
xWriteByte(file.i, value.i)
xWriteShort(file.i, value.i)
xWriteInt(file.i, value.i)
xWriteFloat(file.i, value.f)
xWriteString(file.i, value.s)
xWriteLine(file.i, value.s, ls_flag.i = 0)

; fonts commands
xLoadFont.i(name.s, height.i, bold.i = #False, italic.i = #False, underline.i = #False, fontface.s = "")
xText(x.f, y.f, textString.s, centerx.i = #False, centery.i = #False)
xSetFont(font.i)
xFreeFont(font.i)
xFontWidth.i()
xFontHeight.i()
xStringWidth.i(textString.s)
xStringHeight.i(textString.s)

; graphics commands
xWinMessage.i(message.s)
xGetMaxPixelShaderVersion.i()
xLine(x1.i, y1.i, x2.i, y2.i)
xRect(x.i, y.i, width.i, height.i, solid.i = #False)
xRectsOverlap.i(x1.i, y1.i, width1.i, height1.i, x2.i, y2.i, width2.i, height2.i)
xViewport(x.i, y.i, width.i, height.i)
xOval(x.i, y.i, width.i, height.i, solid.i = #False)
xOrigin(x.i, y.i)
xGetMaxVertexShaderVersion.i()
xGetMaxAntiAlias.i()
xGetMaxTextureFiltering.i()
xSetAntiAliasType(typeID.i)
xAppTitle(title.s)
xSetWND(window.i)
xSetRenderWindow(window.i)
xSetTopWindow(window.i)
xDestroyRenderWindow()
xFlip()
xBackBuffer.i()
xLockBuffer(buffer.i = 0)
xUnlockBuffer(buffer.i = 0)
xWritePixelFast(x.i, y.i, argb.i, buffer.i = -1)
xReadPixelFast.i(x.i, y.i, buffer.i = -1)
xGetPixels.i(buffer.i = -1)
xSaveBuffer(buffer.i, path.s)
xGetCurrentBuffer.i()
xBufferWidth.i(buffer.i = 0)
xBufferHeight.i(buffer.i = 0)
xCatchTimestamp.i()
xGetElapsedTime.f(timeStamp.i)
xSetBuffer(buffer.i = 0)
xSetMRT(buffer.i, frame.i, index.i)
xUnSetMRT()
xGetNumberRT.i()
xTextureBuffer.i(texture.i, frame.i = 0)
xLoadBuffer(buffer.i, path.s)
xWritePixel(x.i, y.i, argb.i, buffer.i = 0)
xCopyPixel(sx.i, sy.i, sourceBuffer.i, dx.i, dy.i, destinationBuffer.i)
xCopyPixelFast(sx.i, sy.i, sourceBuffer.i, dx.i, dy.i, destinationBuffer.i)
xCopyRect(sx.i, sy.i, sw.i, sh.i, dx.i, dy.i, sourceBuffer.i, destinationBuffer.i)
xGraphicsBuffer.i()
xGetColor.i(x.i, y.i)
xReadPixel.i(x.i, y.i, buffer.i = 0)
xGraphicsWidth.i(isVirtual.i = #True)
xGraphicsHeight.i(isVirtual.i = #True)
xGraphicsDepth.i()
xColorAlpha.i()
xColorRed.i()
xColorGreen.i()
xColorBlue.i()
xClsColor(red.i, green.i, blue.i, alpha.i = 255)
xClearWorld(entities.i = #True, brushes.i = #True, textures.i = #True)
xColor(red.i, green.i, blue.i, alpha.i = 255)
xCls()
xUpdateWorld(speed.f = 1.0)
xRenderEntity(camera.i, entity.i, tween.f = 1.0)
xRenderWorld(tween.f = 1.0, renderShadows.i = #False)
xSetAutoTB(flag.i)
xMaxClipPlanes.i()
xWireframe(state.i)
xDither(state.i)
xSetSkinningMethod(skinMethod.i)
xTrisRendered.i()
xDIPCounter.i()
xSurfRendered.i()
xEntityRendered.i()
xAmbientLight(red.i, green.i, blue.i, world.i = 0)
xGetFPS.i()
xAntiAlias(state.i)
xSetTextureFiltering(filter.i)
xStretchRect(texture1.i, x1.i, y1.i, width1.i, height1.i, texture2.i, x2.i, y2.i, width2.i, height2.i, filter.i)
xStretchBackBuffer(texture.i, x.i, y.i, width.i, height.i, filter.i)
xGetDevice.i()
xReleaseGraphics()
xShowPointer()
xHidePointer()
xCreateDSS(width.i, height.i)
xDeleteDSS()
xGridColor(centerRed.i, centerGreen.i, centerBlue.i, gridRed.i, gridGreen.i, gridBlue.i)
xDrawGrid(x.f, z.f, gridSize.i, range.i)
xDrawBBox(draw.i, zOn.i, red.i, green.i, blue.i, alpha.i)
xGraphics3D(width.i = 1024, height.i = 768, depth.i = 0, mode.i = 0, vsync.i = 1)
xGraphicsAspectRatio(aspectRatio.f)
xGraphicsBorderColor(red.i, green.i, blue.i)
xGetRenderWindow.i()
xKey(key.s)
xSetEngineSetting(parameter.s, value.s)
xGetEngineSetting_(parameter.s) As "_xGetEngineSetting@4"
xHWInstancingAvailable.i()
xShaderInstancingAvailable.i()
xSetShaderLayer(layer.i)
xGetShaderLayer.i()
xDrawMovementGizmo(x.f, y.f, z.f, selectMask.i = 0)
xDrawScaleGizmo(x.f, y.f, z.f, selectMask.i = 0, sx.f = 1.0, sy.f = 1.0, sz.f = 1.0)
xDrawRotationGizmo(x.f, y.f, z.f, selectMask.i = 0, pitch.f = 0.0, yaw.f = 0.0, roll.f = 0.0)
xCheckMovementGizmo.i(x.f, y.f, z.f, camera.i, mx.i, my.i)
xCheckScaleGizmo.i(x.f, y.f, z.f, camera.i, mx.i, my.i)
xCheckRotationGizmo.i(x.f, y.f, z.f, camera.i, mx.i, my.i)
xCaptureWorld()
xCountGfxModes.i()
xGfxModeWidth.i(mode.i)
xGfxModeHeight.i(mode.i)
xGfxModeDepth.i(mode.i)
xGfxModeExists.i(width.i, height.i, depth.i)
xAppWindowFrame(state.i)
xMillisecs.i()
xDeltaTime.i(fromInit.i = #False)
xDeltaValue.f(value.f, time.i = 0)
xAddDeviceLostCallback(func.i)
xDeleteDeviceLostCallback(func.i)

; images commands
xImageColor(image.i, red.i, green.i, blue.i)
xImageAlpha(image.i, alpha.f)
xImageBuffer.i(image.i, frame.i = 0)
xCreateImage.i(width.i, height.i, frame.i = 1)
xGrabImage(image.i, x.i, y.i, frame.i = 0)
xFreeImage(image.i)
xLoadImage.i(path.s)
xLoadAnimImage.i(path.s, width.i, height.i, startFrame.i, frames.i)
xSaveImage(image.i, path.s, frame.i = 0)
xDrawImage(image.i, x.f, y.f, frame.i = 0)
xDrawImageRect(image.i, x.f, y.f, rectx.f, recty.f, rectWidth.f, rectHeight.f, frame.i = 0)
xScaleImage(image.i, x.f, y.f)
xResizeImage(image.i, width.f, height.f)
xRotateImage(image.i, angle.f)
xImageAngle.f(image.i)
xImageWidth.i(image.i)
xImageHeight.i(image.i)
xImagesCollide.i(image1.i, x1.i, y1.i, frame1.i, image2.i, x2.i, y2.i, frame2.i)
xImageRectCollide.i(image.i, x.i, y.i, frame.i, rectx.i, recty.i, rectWidth.i, rectHeight.i)
xImageRectOverlap.i(image.i, x.f, y.f, rectx.f, recty.f, rectWidth.f, rectHeight.f)
xImageXHandle.i(image.i)
xImageYHandle.i(image.i)
xHandleImage(image.i, x.f, y.f)
xMidHandle(image.i)
xAutoMidHandle(state.i)
xTileImage(image.i, x.f, y.f, frame.i = 0)
xImagesOverlap.i(image1.i, x1.f, y1.f, image2.i, x2.f, y2.f)
xMaskImage(image.i, red.i, green.i, blue.i)
xCopyImage.i(image.i)
xDrawBlock(image.i, x.f, y.f, frame.i = 0)
xDrawBlockRect(image.i, x.f, y.f, rectx.f, recty.f, rectWidth.f, rectHeight.f, frame.i = 0)
xImageActualWidth.i(image.i)
xImageActualHeight.i(image.i)

; inputs commands
xFlushKeys()
xFlushMouse()
xKeyHit.i(key.i)
xKeyUp.i(key.i)
xWaitKey()
xMouseHit.i(key.i)
xKeyDown.i(key.i)
xGetKey.i()
xMouseDown.i(key.i)
xMouseUp.i(key.i)
xGetMouse.i()
xMouseX.i()
xMouseY.i()
xMouseZ.i()
xMouseXSpeed.i()
xMouseYSpeed.i()
xMouseZSpeed.i()
xMouseSpeed.i()
xMoveMouse(x.i, y.i)

; joysticks commands
xJoyType.i(portID.i = 0)
xJoyDown.i(key.i, portID.i = 0)
xJoyHit.i(key.i, portID.i = 0)
xGetJoy.i(portID.i = 0)
xFlushJoy()
xWaitJoy.i(portID.i = 0)
xJoyX.f(portID.i = 0)
xJoyY.f(portID.i = 0)
xJoyZ.f(portID.i = 0)
xJoyU.f(portID.i = 0)
xJoyV.f(portID.i = 0)
xJoyPitch.f(portID.i = 0)
xJoyYaw.f(portID.i = 0)
xJoyRoll.f(portID.i = 0)
xJoyHat.f(portID.i = 0)
xJoyXDir.i(portID.i = 0)
xJoyYDir.i(portID.i = 0)
xJoyZDir.i(portID.i = 0)
xJoyUDir.i(portID.i = 0)
xJoyVDir.i(portID.i = 0)
xCountJoys.i()

; lights commands
xCreateLight.i(typeID.i = 1)
xLightShadowEpsilons(light.i, epsilon1.f, epsilon2.f)
xLightEnableShadows(light.i, state.i)
xLightShadowsEnabled.i(light.i)
xLightRange(light.i, range.f)
xLightColor(light.i, red.i, green.i, blue.i)
xLightConeAngles(light.i, inner.f, outer.f)

; logging commands
xCreateLog.i(target.i = 1, level.i = 0, filename.s = "xors_log.html", cssfilename.s = "")
xCloseLog.i()
xGetLogString_() As "_xGetLogString@0"
xClearLogString()
xSetLogLevel(level.i = 2)
xSetLogTarget(target.i = 1)
xGetLogLevel.i()
xGetLogTarget.i()
xLogInfo(message.s, func.s = "", file.s = "", line.i = -1)
xLogMessage(message.s, func.s = "", file.s = "", line.i = -1)
xLogWarning(message.s, func.s = "", file.s = "", line.i = -1)
xLogError(message.s, func.s = "", file.s = "", line.i = -1)
xLogFatal(message.s, func.s = "", file.s = "", line.i = -1)

; meshes commands
xCreateMesh.i(parent.i = 0)
xLoadMesh.i(path.s, parent.i = 0)
xLoadMeshWithChild.i(path.s, parent.i = 0)
xLoadAnimMesh.i(path.s, parent.i = 0)
xCreateCube.i(parent.i = 0)
xCreateSphere.i(segments.i = 16, parent.i = 0)
xCreateCylinder.i(segments.i = 16, solid.i = #True, parent.i = 0)
xCreateTorus.i(segments.i = 16, R.f = 1.0, r_tube.f = 0.025, parent.i = 0)
xCreateCone.i(segments.i = 16, solid.i = #True, parent.i = 0)
xCopyMesh.i(entity.i, parent.i = 0)
xAddMesh(source.i, destination.i)
xFlipMesh(entity.i)
xPaintMesh(entity.i, brush.i)
xFitMesh(entity.i, x.f, y.f, z.f, width.f, height.f, depth.f, uniform.i = #False)
xMeshWidth.f(entity.i, recursive.i = #False)
xMeshHeight.f(entity.i, recursive.i = #False)
xMeshDepth.f(entity.i, recursive.i = #False)
xScaleMesh(entity.i, x.f, y.f, z.f)
xRotateMesh(entity.i, x.f, y.f, z.f)
xPositionMesh(entity.i, x.f, y.f, z.f)
xUpdateNormals(entity.i)
xUpdateN(entity.i)
xUpdateTB(entity.i)
xMeshesBBIntersect.i(entity1.i, entity2.i)
xMeshesIntersect.i(entity1.i, entity2.i)
xGetMeshVB.i(entity.i)
xGetMeshIB.i(entity.i)
xGetMeshVBSize.i(entity.i)
xGetMeshIBSize.i(entity.i)
xDeleteMeshVB(entity.i)
xDeleteMeshIB(entity.i)
xCountSurfaces.i(entity.i)
xGetSurface.i(entity.i, index.i)
xCreatePivot.i(parent.i = 0)
xFindSurface.i(entity.i, brush.i)
xCreatePoly.i(sides.i, parent.i = 0)
xMeshSingleSurface(entity.i)
xSaveMesh.i(entity.i, path.s)
xLightMesh(entity.i, red.i, green.i, blue.i, range.f = 0.0, lightX.f = 0.0, lightY.f = 0.0, lightZ.f = 0.0)
xMeshPrimitiveType(entity.i, ptype.i)

; particles commands
xParticlePosition(particle.i, x.f, y.f, z.f)
xParticleX.f(particle.i)
xParticleY.f(particle.i)
xParticleZ.f(particle.i)
xParticleVeclocity(particle.i, x.f, y.f, z.f)
xParticleVX.f(particle.i)
xParticleVY.f(particle.i)
xParticleVZ.f(particle.i)
xParticleRotation(particle.i, x.f, y.f, z.f)
xParticlePitch.f(particle.i)
xParticleYaw.f(particle.i)
xParticleRoll.f(particle.i)
xParticleTorque(particle.i, x.f, y.f, z.f)
xParticleTPitch.f(particle.i)
xParticleTYaw.f(particle.i)
xParticleTRoll.f(particle.i)
xParticleSetAlpha(particle.i, alpha.f)
xParticleGetAlpha.f(particle.i)
xParticleColor(particle.i, x.f, y.f, z.f)
xParticleRed.f(particle.i)
xParticleGreen.f(particle.i)
xParticleBlue.f(particle.i)
xParticleScale(particle.i, x.f, y.f)
xParticleSX.f(particle.i)
xParticleSY.f(particle.i)
xParticleScaleSpeed(particle.i, x.f, y.f)
xParticleScaleSpeedX.f(particle.i)
xParticleScaleSpeedY.f(particle.i)

; physics commands
xEntityAddDummyShape(entity.i)
xEntityAddBoxShape(entity.i, mass.f, width.f = 0.0, height.f = 0.0, depth.f = 0.0)
xEntityAddSphereShape(entity.i, mass.f, radius.f = 0.0)
xEntityAddCapsuleShape(entity.i, mass.f, radius.f = 0.0, height.f = 0.0)
xEntityAddConeShape(entity.i, mass.f, radius.f = 0.0, height.f = 0.0)
xEntityAddCylinderShape(entity.i, mass.f, width.f = 0.0, height.f = 0.0, depth.f = 0.0)
xEntityAddTriMeshShape(entity.i)
xEntityAddTriMeshShapeProxy(entity.i, proxy.i)
xEntityAddConvexShape(entity.i, mass.f)
xEntityAddConvexShapeProxy(entity.i, proxy.i, mass.f)
xEntityAddConcaveShape(entity.i, mass.f)
xEntityAddConcaveShapeProxy(entity.i, proxy.i, mass.f)
xEntityAddTerrainShape(entity.i)
xEntityAttachBody(entity.i, body.i)
xEntityDetachBody.i(entity.i)
xFreeEntityBody(entity.i)
xEntityAddCompoundShape(entity.i, mass.f)
xEntityCompoundAddBox.i(entity.i, width.f, height.f, depth.f)
xEntityCompoundAddSphere.i(entity.i, radius.f)
xEntityCompoundAddCapsule.i(entity.i, radius.f, height.f)
xEntityCompoundAddCone.i(entity.i, radius.f, height.f)
xEntityCompoundAddCylinder.i(entity.i, radius.f, height.f)
xEntityCompoundCountChildren.i(entity.i)
xEntityCompoundRemoveChild(entity.i, index.i)
xEntityCompoundChildSetPosition(entity.i, index.i, x.f, y.f, z.f)
xEntityCompoundChildGetX.f(entity.i, index.i)
xEntityCompoundChildGetY.f(entity.i, index.i)
xEntityCompoundChildGetZ.f(entity.i, index.i)
xEntityCompoundChildSetRotation(entity.i, index.i, pitch.f, yaw.f, roll.f)
xEntityCompoundChildGetPitch.f(entity.i, index.i)
xEntityCompoundChildGetYaw.f(entity.i, index.i)
xEntityCompoundChildGetRoll.f(entity.i, index.i)
xCreateHingeJoint.i(firstBody.i, secondBody.i, pivotX.f, pivotY.f, pivotZ.f, axisX.f, axisY.f, axisZ.f, isGlobal.i = #False)
xCreateBallJoint.i(firstBody.i, secondBody.i, pivotX.f, pivotY.f, pivotZ.f, isGlobal.i = #False)
xCreateD6Joint.i(firstBody.i, secondBody.i, pivot1X.f, pivot1Y.f, pivot1Z.f, pivot2X.f, pivot2Y.f, pivot2Z.f, isGlobal1.i = #False, isGlobal2.i = #False)
xCreateD6SpringJoint.i(firstBody.i, secondBody.i, pivot1X.f, pivot1Y.f, pivot1Z.f, pivot2X.f, pivot2Y.f, pivot2Z.f, isGlobal1.i = #False, isGlobal2.i = #False)
xJointHingeGetAngle.f(joint.i)
xJointD6GetPitchAngle.f(joint.i)
xJointD6GetYawAngle.f(joint.i)
xJointD6GetRollAngle.f(joint.i)
xJointD6GetAngle.f(joint.i, axis.i = 0)
xJointDisableCollisions(joint.i, state.i)
xJointEnable(joint.i, state.i)
xJointIsEnabled.i(joint.i)
xJointGetImpulse.f(joint.i)
xFreeJoint(joint.i)
xJointBallSetPivot(joint.i, x.f, y.f, z.f, isGlobal.i = #False)
xJointBallGetPivotX.f(joint.i, isGlobal.i = #False)
xJointBallGetPivotY.f(joint.i, isGlobal.i = #False)
xJointBallGetPivotZ.f(joint.i, isGlobal.i = #False)
xJointD6SetLimits(joint.i, axis.i, lower.f, upper.f)
xJointD6SetLowerLinearLimits(joint.i, lowerX.f, lowerY.f, lowerZ.f)
xJointD6SetUpperLinearLimits(joint.i, upperX.f, upperY.f, upperZ.f)
xJointD6SetLowerAngularLimits(joint.i, lowerX.f, lowerY.f, lowerZ.f)
xJointD6SetUpperAngularLimits(joint.i, upperX.f, upperY.f, upperZ.f)
xJointD6SetLinearLimits(joint.i, lowerX.f, lowerY.f, lowerZ.f, upperX.f, upperY.f, upperZ.f)
xJointD6SetAngularLimits(joint.i, lowerX.f, lowerY.f, lowerZ.f, upperX.f, upperY.f, upperZ.f)
xJointD6GetLinearLowerX.f(joint.i)
xJointD6GetLinearLowerY.f(joint.i)
xJointD6GetLinearLowerZ.f(joint.i)
xJointD6GetLinearUpperX.f(joint.i)
xJointD6GetLinearUpperY.f(joint.i)
xJointD6GetLinearUpperZ.f(joint.i)
xJointD6GetAngularLowerX.f(joint.i)
xJointD6GetAngularLowerY.f(joint.i)
xJointD6GetAngularLowerZ.f(joint.i)
xJointD6GetAngularUpperX.f(joint.i)
xJointD6GetAngularUpperY.f(joint.i)
xJointD6GetAngularUpperZ.f(joint.i)
xJointD6SpringSetParam(joint.i, index.i, enabled.i, damping.f = 1.0, stiffness.f = 1.0)
xJointHingeSetAxis(joint.i, x.f, y.f, z.f)
xJointHingeSetLimits(joint.i, lowerLimit.f, upperLimit.f, softness.f = 0.9, biasFactor.f = 0.3, relaxationFactor.f = 1.0)
xJointHingeGetLowerLimit.f(joint.i)
xJointHingeGetUpperLimit.f(joint.i)
xJointEnableMotor(joint.i, enabled.i, targetVelocity.f, maxForce.f, index.i = 0)
xJointHingeSetMotorTarget(joint.i, targetAngle.f, deltaTime.f)
xJointGetEntityA.i(joint.i)
xJointGetEntityB.i(joint.i)
xEntityApplyCentralForce(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityApplyCentralImpulse(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityApplyTorque(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityApplyTorqueImpulse(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityApplyForce(entity.i, x.f, y.f, z.f, pointx.f, pointy.f, pointz.f, isGlobal.i = #True, globalPoint.i = #True)
xEntityApplyImpulse(entity.i, x.f, y.f, z.f, pointx.f, pointy.f, pointz.f, isGlobal.i = #True, globalPoint.i = #True)
xEntityReleaseForces(entity.i)
xWorldSetGravity(x.f, y.f, z.f, world.i = 0)
xWorldGetGravityX.f(world.i = 0)
xWorldGetGravityY.f(world.i = 0)
xWorldGetGravityZ.f(world.i = 0)
xEntitySetGravity(entity.i, x.f, y.f, z.f)
xEntityGetGravityX.f(entity.i)
xEntityGetGravityY.f(entity.i)
xEntityGetGravityZ.f(entity.i)
xEntitySetLinearVelocity(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityGetLinearVelocityX.f(entity.i, isGlobal.i = #True)
xEntityGetLinearVelocityY.f(entity.i, isGlobal.i = #True)
xEntityGetLinearVelocityZ.f(entity.i, isGlobal.i = #True)
xEntitySetAngularVelocity(entity.i, x.f, y.f, z.f, isGlobal.i = #True)
xEntityGetAngularVelocityX.f(entity.i, isGlobal.i = #True)
xEntityGetAngularVelocityY.f(entity.i, isGlobal.i = #True)
xEntityGetAngularVelocityZ.f(entity.i, isGlobal.i = #True)
xEntitySetDamping(entity.i, linear.f, angular.f)
xEntityGetLinearDamping.f(entity.i)
xEntityGetAngularDamping.f(entity.i)
xEntitySetFriction(entity.i, friction.f)
xEntityGetFriction.f(entity.i)
xEntitySetAnisotropicFriction(entity.i, fx.f, fy.f, fz.f)
xEntityGetAnisotropicFrictionX.f(entity.i)
xEntityGetAnisotropicFrictionY.f(entity.i)
xEntityGetAnisotropicFrictionZ.f(entity.i)
xEntitySetLinearFactor(entity.i, x.f, y.f, z.f)
xEntityGetLinearFactorX.f(entity.i)
xEntityGetLinearFactorY.f(entity.i)
xEntityGetLinearFactorZ.f(entity.i)
xEntitySetAngularFactor(entity.i, x.f, y.f, z.f)
xEntityGetAngularFactorX.f(entity.i)
xEntityGetAngularFactorY.f(entity.i)
xEntityGetAngularFactorZ.f(entity.i)
xEntitySetRestitution(entity.i, restitution.f)
xEntityGetRestitution.f(entity.i)
xEntitySetMass(entity.i, mass.f)
xEntityGetMass.f(entity.i)
xEntityCountContacts.i(entity.i)
xEntityGetContactX.f(entity.i, index.i)
xEntityGetContactY.f(entity.i, index.i)
xEntityGetContactZ.f(entity.i, index.i)
xEntityGetContactNX.f(entity.i, index.i)
xEntityGetContactNY.f(entity.i, index.i)
xEntityGetContactNZ.f(entity.i, index.i)
xEntityGetContactDistance.f(entity.i, index.i)
xEntityGetContact.i(entity.i, index.i)
xEntityGetContactImpulse.f(entity.i, index.i)
xEntitySetCollisionGroup(entity.i, group.i)
xEntityGetCollisionGroup.i(entity.i)
xEntitySetContactGroup(entity.i, group.i)
xEntityGetContactGroup.i(entity.i)
xEntitySetRaycastGroup(entity.i, group.i)
xEntityGetRaycastGroup.i(entity.i)
xPhysicsSetCollisionFilter(group0.i, group1.i, state.i)
xPhysicsGetCollisionFilter.i(group0.i, group1.i)
xPhysicsSetContactFilter(group0.i, group1.i, state.i)
xPhysicsGetContactFilter.i(group0.i, group1.i)
xPhysicsSetRaycastFilter(rayGroup.i, bodyGroup.i, state.i)
xPhysicsGetRaycastFilter.i(rayGroup.i, bodyGroup.i)
xEntityIsSleeping.i(entity.i)
xEntityDisableSleeping(entity.i, state.i = 1)
xEntityWakeUp(entity.i)
xEntitySleep(entity.i)
xEntitySetSleepingThresholds(entity.i, linearThreshold.f, angularThreshold.f)
xEntityGetLinearSleepingThreshold.f(entity.i)
xEntityGetAngularSleepingThreshold.f(entity.i)
xPhysicsRayCast(fromX.f, fromY.f, fromZ.f, toX.f, toY.f, toZ.f, rcType.i = 0, rayGroup.i = 0)
xPhysicsGetHitEntity.i(index.i = 0)
xPhysicsGetHitPointX.f(index.i = 0)
xPhysicsGetHitPointY.f(index.i = 0)
xPhysicsGetHitPointZ.f(index.i = 0)
xPhysicsGetHitNormalX.f(index.i = 0)
xPhysicsGetHitNormalY.f(index.i = 0)
xPhysicsGetHitNormalZ.f(index.i = 0)
xPhysicsGetHitDistance.f(index.i = 0)
xPhysicsCountHits.i()
xEntityBodyLocalPosition(entity.i, x.f, y.f, z.f)
xEntityBodyLocalRotation(entity.i, pitch.f, yaw.f, roll.f)
xEntityBodyLocalScale(entity.i, x.f, y.f, z.f)
xWorldSetFrequency(frequency.f, world.i = 0)
xEntityMakeKinematic(entity.i, state.i)
xEntityIsKinematic.i(entity.i)
xPhysicsDebugRender(state.i)
xEntityDisableSimulation(entity.i, state.i)
xEntityHasBody.i(entity.i)
xEntityCreateVehicle(chassisEntity.i)
xEntityFreeVehicle(chassisEntity.i)
xEntityCountWheels.i(chassisEntity.i)
xEntityAddWheel.i(chassisEntity.i, wheelEntity.i)
xEntityWheelSetRadius(chassisEntity.i, index.i, radius.f)
xEntityWheelSetAxle(chassisEntity.i, index.i, x.f, y.f, z.f)
xEntityWheelSetRay(chassisEntity.i, index.i, x.f, y.f, z.f)
xEntityWheelSetSuspensionLength(chassisEntity.i, index.i, length.f)
xEntityWheelSetBrake(chassisEntity.i, index.i, brake.f)
xEntityWheelSetMaxSuspensionForce(chassisEntity.i, index.i, force.f)
xEntityWheelSetMaxSuspensionTravel(chassisEntity.i, index.i, travel.f)
xEntityWheelSetSuspensionStiffness(chassisEntity.i, index.i, stiffness.f)
xEntityWheelSetSuspensionDamping(chassisEntity.i, index.i, damping.f)
xEntityWheelSetSuspensionCompression(chassisEntity.i, index.i, compression.f)
xEntityWheelSetFriction(chassisEntity.i, index.i, friction.f)
xEntityWheelSetEngineForce(chassisEntity.i, index.i, force.f)
xEntityWheelSetRollInfluence(chassisEntity.i, index.i, roll.f)
xEntityWheelSetRotation(chassisEntity.i, index.i, rotation.f)
xEntityWheelSetSteering(chassisEntity.i, index.i, steering.f)
xEntityWheelSetConnectionPoint(chassisEntity.i, index.i, x.f, y.f, z.f, isGlobal.i = #False)
xEntityWheelGetSuspensionLength.f(chassisEntity.i, index.i)
xEntityWheelGetPitch.f(chassisEntity.i, index.i)
xEntityWheelGetYaw.f(chassisEntity.i, index.i)
xEntityWheelGetRoll.f(chassisEntity.i, index.i)
xEntityWheelGetContactEntity.i(chassisEntity.i, index.i)

; posteffects commands
xLoadPostEffect.i(path.s)
xFreePostEffect(postEffect.i)
xSetPostEffect(index.i, postEffect.i, technique.s = "MainTechnique")
xRenderPostEffects()
xSetPostEffectInt(postEffect.i, name.s, value.i)
xSetPostEffectFloat(postEffect.i, name.s, value.f)
xSetPostEffectBool(postEffect.i, name.s, value.i)
xSetPostEffectVector(postEffect.i, name.s, x.f, y.f, z.f, w.f = 1.0)
xSetPostEffectTexture(postEffect.i, name.s, texture.i, frame.i = 0)
xDeletePostEffectConstant(postEffect.i, name.s)
xClearPostEffectConstants(postEffect.i)

; psystems commands
xCreatePSystem.i(pointSprites.i = #False)
xPSystemType.i(psystem.i)
xPSystemSetBlend(psystem.i, mode.i)
xPSystemGetBlend.i(psystem.i)
xPSystemSetMaxParticles(psystem.i, maxNumber.i)
xPSystemGetMaxParticles.i(psystem.i)
xPSystemSetEmitterLifetime(psystem.i, lifetime.i)
xPSystemGetEmitterLifetime.i(psystem.i)
xPSystemSetParticleLifetime(psystem.i, lifetime.i)
xPSystemGetParticleLifetime.i(psystem.i)
xPSystemSetCreationInterval(psystem.i, interval.i)
xPSystemGetCreationInterval.i(psystem.i)
xPSystemSetCreationFrequency(psystem.i, frequency.i)
xPSystemGetCreationFrequency.i(psystem.i)
xPSystemSetTexture(psystem.i, texture.i, frames.i, speed.f)
xPSystemGetTexture.i(psystem.i)
xPSystemGetTextureFrames.i(psystem.i)
xPSystemGetTextureAnimationSpeed.i(psystem.i)
xPSystemSetOffset(psystem.i, minx.f, miny.f, minz.f, maxx.f, maxy.f, maxz.f)
xPSystemGetOffsetMinX.f(psystem.i)
xPSystemGetOffsetMinY.f(psystem.i)
xPSystemGetOffsetMinZ.f(psystem.i)
xPSystemGetOffsetMaxX.f(psystem.i)
xPSystemGetOffsetMaxY.f(psystem.i)
xPSystemGetOffsetMaxZ.f(psystem.i)
xPSystemSetVelocity(psystem.i, minx.f, miny.f, minz.f, maxx.f, maxy.f, maxz.f)
xPSystemGetVelocityMinX.f(psystem.i)
xPSystemGetVelocityMinY.f(psystem.i)
xPSystemGetVelocityMinZ.f(psystem.i)
xPSystemGetVelocityMaxX.f(psystem.i)
xPSystemGetVelocityMaxY.f(psystem.i)
xPSystemGetVelocityMaxZ.f(psystem.i)
xPSystemEnableFixedQuads(psystem.i, state.i)
xPSystemFixedQuadsUsed.i(psystem.i)
xPSystemSetTorque(psystem.i, minx.f, miny.f, minz.f, maxx.f, maxy.f, maxz.f)
xPSystemGetTorqueMinX.f(psystem.i)
xPSystemGetTorqueMinY.f(psystem.i)
xPSystemGetTorqueMinZ.f(psystem.i)
xPSystemGetTorqueMaxX.f(psystem.i)
xPSystemGetTorqueMaxY.f(psystem.i)
xPSystemGetTorqueMaxZ.f(psystem.i)
xPSystemSetGravity(psystem.i, gravity.f)
xPSystemGetGravity.f(psystem.i)
xPSystemSetAlpha(psystem.i, alpha.f)
xPSystemGetAlpha.f(psystem.i)
xPSystemSetFadeSpeed(psystem.i, speed.f)
xPSystemGetFadeSpeed.f(psystem.i)
xPSystemSetParticleSize(psystem.i, minx.f, miny.f, maxx.f, maxy.f)
xPSystemGetSizeMinX.f(psystem.i)
xPSystemGetSizeMinY.f(psystem.i)
xPSystemGetSizeMaxX.f(psystem.i)
xPSystemGetSizeMaxY.f(psystem.i)
xPSystemSetScaleSpeed(psystem.i, minx.f, miny.f, maxx.f, maxy.f)
xPSystemGetScaleSpeedMinX.f(psystem.i)
xPSystemGetScaleSpeedMinY.f(psystem.i)
xPSystemGetScaleSpeedMaxX.f(psystem.i)
xPSystemGetScaleSpeedMaxY.f(psystem.i)
xPSystemSetAngles(psystem.i, minx.f, miny.f, minz.f, maxx.f, maxy.f, maxz.f)
xPSystemGetAnglesMinX.f(psystem.i)
xPSystemGetAnglesMinY.f(psystem.i)
xPSystemGetAnglesMinZ.f(psystem.i)
xPSystemGetAnglesMaxX.f(psystem.i)
xPSystemGetAnglesMaxY.f(psystem.i)
xPSystemGetAnglesMaxZ.f(psystem.i)
xPSystemSetColorMode(psystem.i, mode.i)
xPSystemGetColorMode.i(psystem.i)
xPSystemSetColors(psystem.i, sred.f, sgreen.f, sblue.f, ered.f, egreen.f, eblue.f)
xPSystemGetBeginColorRed.f(psystem.i)
xPSystemGetBeginColorGreen.f(psystem.i)
xPSystemGetBeginColorBlue.f(psystem.i)
xPSystemGetEndColorRed.f(psystem.i)
xPSystemGetEndColorGreen.f(psystem.i)
xPSystemGetEndColorBlue.f(psystem.i)
xFreePSystem(psystem.i)
xPSystemSetParticleParenting(psystem.i, mode.i)
xPSystemGetParticleParenting.i(psystem.i)

; raypicks commands
xLinePick.i(x.f, y.f, z.f, dx.f, dy.f, dz.f, distance.f = 0.0)
xEntityPick.i(entity.i, range.f = 0.0)
xCameraPick.i(camera.i, x.i, y.i)
xPickedNX.f()
xPickedNY.f()
xPickedNZ.f()
xPickedX.f()
xPickedY.f()
xPickedZ.f()
xPickedEntity.i()
xPickedSurface.i()
xPickedTriangle.i()
xPickedTime.i()

; shadows commands
xSetShadowsBlur(blurLevel.i)
xSetShadowShader(path.s)
xInitShadows.i(dirSize.i, spotSize.i, pointSize.i)
xSetShadowParams(splitPlanes.i = 4, splitLambda.f = 0.95, useOrtho.i = #True, lightDist.f = 300.0)
xRenderShadows(mainCamera.i, texture.i)
xShadowPriority(priority.i)
xCameraDisableShadows(camera.i)
xCameraEnableShadows(camera.i)
xEntityCastShadows(entity.i, light.i, state.i)
xEntityReceiveShadows(entity.i, light.i, state.i)
xEntityIsCaster.i(entity.i, light.i)
xEntityIsReceiver.i(entity.i, light.i)

; sounds commands
xLoadSound.i(path.s)
xLoad3DSound.i(path.s)
xFreeSound(sound.i)
xLoopSound(sound.i)
xSoundPitch(sound.i, pitch.i)
xSoundVolume(sound.i, volume.f)
xSoundPan(sound.i, pan.f)
xPlaySound.i(sound.i)
xStopChannel(channel.i)
xPauseChannel(channel.i)
xResumeChannel(channel.i)
xPlayMusic.i(path.s)
xChannelPitch(channel.i, pitch.i)
xChannelVolume(channel.i, volume.f)
xChannelPan(channel.i, pan.f)
xChannelPlaying.i(channel.i)
xEmitSound.i(sound.i, entity.i)
xCreateListener.i(parent.i = 0, roFactor.f = 1.0, doplerFactor.f = 1.0, distFactor.f = 1.0)
xGetListener.i()
xInitalizeSound.i()

; sprites commands
xCreateSprite.i(parent.i = 0)
xSpriteViewMode(sprite.i, mode.i)
xHandleSprite(sprite.i, x.f, y.f)
xLoadSprite.i(path.s, flags.i = 9, parent.i = 0)
xRotateSprite(sprite.i, angle.f)
xScaleSprite(sprite.i, xScale.f, yScale.f)

; surfaces commands
xCreateSurface.i(entity.i, brush.i = 0, dynamic.i = #False)
xGetSurfaceBrush.i(surface.i)
xAddVertex.i(surface.i, x.f, y.f, z.f, u.f = 0.0, v.f = 0.0, w.f = 0.0)
xAddTriangle.i(surface.i, v0.i, v1.i, v2.i)
xSetSurfaceFrustumSphere(surface.i, x.f, y.f, z.f, radii.f)
xVertexCoords(surface.i, vertex.i, x.f, y.f, z.f)
xVertexNormal(surface.i, vertex.i, x.f, y.f, z.f)
xVertexTangent(surface.i, vertex.i, x.f, y.f, z.f)
xVertexBinormal(surface.i, vertex.i, x.f, y.f, z.f)
xVertexColor(surface.i, vertex.i, red.i, green.i, blue.i, alpha.f = 1.0)
xVertexTexCoords(surface.i, vertex.i, u.f, v.f, w.f = 1.0, textureSet.i = 0)
xCountVertices.i(surface.i)
xVertexX.f(surface.i, vertex.i)
xVertexY.f(surface.i, vertex.i)
xVertexZ.f(surface.i, vertex.i)
xVertexNX.f(surface.i, vertex.i)
xVertexNY.f(surface.i, vertex.i)
xVertexNZ.f(surface.i, vertex.i)
xVertexTX.f(surface.i, vertex.i)
xVertexTY.f(surface.i, vertex.i)
xVertexTZ.f(surface.i, vertex.i)
xVertexBX.f(surface.i, vertex.i)
xVertexBY.f(surface.i, vertex.i)
xVertexBZ.f(surface.i, vertex.i)
xVertexU.f(surface.i, vertex.i, textureSet.i = 0)
xVertexV.f(surface.i, vertex.i, textureSet.i = 0)
xVertexW.f(surface.i, vertex.i, textureSet.i = 0)
xVertexRed.f(surface.i, vertex.i)
xVertexGreen.f(surface.i, vertex.i)
xVertexBlue.f(surface.i, vertex.i)
xVertexAlpha.f(surface.i, vertex.i)
xTriangleVertex.i(surface.i, triangle.i, corner.i)
xCountTriangles.i(surface.i)
xPaintSurface(surface.i, brush.i)
xClearSurface(surface.i, vertices.i = #True, triangles.i = #True)
xGetSurfaceTexture.i(surface.i, index.i = 0)
xFreeSurface(surface.i)
xSurfacePrimitiveType(surface.i, ptype.i)
xSurfaceTexture(surface.i, texture.i, frame.i, index.i)
xSurfaceColor(surface.i, red.i, green.i, blue.i)
xSurfaceAlpha(surface.i, alpha.f)
xSurfaceShininess(surface.i, shininess.f)
xSurfaceBlend(surface.i, blendMode.i)
xSurfaceFX(surface.i, fxFlags.i)
xSurfaceAlphaRef(surface.i, alphaRef.i)
xSurfaceAlphaFunc(surface.i, alphaFunc.i)

; sysinfos commands
xCPUName_() As "_xCPUName@0"
xCPUVendor_() As "_xCPUVendor@0"
xCPUFamily.i()
xCPUModel.i()
xCPUStepping.i()
xCPUSpeed.i()
xVideoInfo_() As "_xVideoInfo@0"
xVideoAspectRatio.f()
xVideoAspectRatioStr_() As "_xVideoAspectRatioStr@0"
xGetTotalPhysMem.f()
xGetAvailPhysMem.f()
xGetTotalPageMem.f()
xGetAvailPageMem.f()
xGetTotalVidMem.f()
xGetAvailVidMem.f()
xGetTotalVidLocalMem.f()
xGetAvailVidLocalMem.f()
xGetTotalVidNonlocalMem.f()
xGetAvailVidNonlocalMem.f()
xGetXors3dVersion_() As "_xGetXors3dVersion@0"
xGetXors3dMajorVersion.i()
xGetXors3dMinorVersion.i()
xGetXors3dRevision.i()

; terrains commands
xLoadTerrain.i(path.s, parent.i = 0)
xCreateTerrain.i(size.i, parent.i = 0)
xTerrainShading(terrain.i, state.i = #False)
xTerrainHeight.f(terrain.i, x.i, y.i)
xTerrainSize.i(terrain.i)
xTerrainX.f(terrain.i, x.f, y.f, z.f)
xTerrainY.f(terrain.i, x.f, y.f, z.f)
xTerrainZ.f(terrain.i, x.f, y.f, z.f)
xModifyTerrain(terrain.i, x.i, y.i, height.f, realtime.i = #False)
xTerrainDetail(terrain.i, detail.i)
xTerrainSplatting(terrain.i, state.i)
xLoadTerrainTexture.i(path.s)
xFreeTerrainTexture(texture.i)
xTerrainTextureLightmap(texture.i, state.i)
xTerrainTexture(terrain.i, texture.i)
xTerrainViewZone(terrain.i, viewZone.i, texturingZone.i = -1)
xTerrainLODs(lodsCount.i)

; textures commands
xTextureWidth.i(texture.i)
xTextureHeight.i(texture.i)
xCreateTexture.i(width.i, height.i, flags.i = 9, frames.i = 1)
xFreeTexture(texture.i)
xSetTextureFilter(texture.i, mode.i)
xTextureBlend(texture.i, blend.i)
xTextureCoords(texture.i, coords.i)
xTextureFilter(matchText.s, flags.i)
xClearTextureFilters()
xLoadTexture.i(path.s, flags.i = 9)
xTextureName_(texture.i) As "_xTextureName@4"
xPositionTexture(texture.i, x.f, y.f)
xScaleTexture(texture.i, x.f, y.f)
xRotateTexture(texture.i, angle.f)
xLoadAnimTexture.i(path.s, flags.i, width.i, height.i, startFrame.i, frames.i)
xCreateTextureFromData.i(pixelsData.i, width.i, height.i, flags.i = 9, frames.i = 1)
xGetTextureData.i(texture.i, frame.i = 0)
xGetTextureDataPitch.i(texture.i, frame.i = 0)
xGetTextureSurface.i(texture.i, frame.i = 0)
xGetTextureFrames.i(texture.i)
xSetCubeFace(texture.i, face.i)
xSetCubeMode(texture.i, mode.i)
xGetTextureBlend.i(texture.i)
xGetTextureX.f(texture.i)
xGetTextureY.f(texture.i)
xGetTextureScaleX.f(texture.i)
xGetTextureScaleY.f(texture.i)
xGetTextureAngle.f(texture.i)
xGetTextureCoords.i(texture.i)
xGetCubeFace.i(texture.i)
xGetCubeMode.i(texture.i)
xGetTextureFlags.i(texture.i)
xSetTextureFlags(texture.i, flags.i)
xTextureCounter.i(texture.i)

; transforms commands
xVectorPitch.f(x.f, y.f, z.f)
xVectorYaw.f(x.f, y.f, z.f)
xDeltaPitch.f(entity1.i, entity2.i)
xDeltaYaw.f(entity1.i, entity2.i)
xTFormedX.f()
xTFormedY.f()
xTFormedZ.f()
xTFormPoint(x.f, y.f, z.f, source.i, destination.i)
xTFormVector(x.f, y.f, z.f, source.i, destination.i)
xTFormNormal(x.f, y.f, z.f, source.i, destination.i)

; videos commands
xOpenMovie.i(path.s)
xCloseMovie(video.i)
xDrawMovie(video.i, x.i = 0, y.i = 0, width.i = -1, height.i = -1)
xMovieWidth.i(video.i)
xMovieHeight.i(video.i)
xMoviePlaying.i(video.i)
xMovieSeek(video.i, time.f, relative.i = #False)
xMovieLength.f(video.i)
xMovieCurrentTime.f(video.i)
xMoviePause(video.i)
xMovieResume(video.i)
xMovieTexture.i(video.i)

; worlds commands
xCreateWorld.i()
xSetActiveWorld(world.i)
xGetActiveWorld.i()
xGetDefaultWorld.i()
xDeleteWorld(world.i)
EndImport